// Load jquery and google maps scripts
window.onload = loadScript;
// Globals
var map;
var busStops = [];
var busStart;
var busEnd;
var busTransit;
var routes;
var bounds;
var routeStops = [];
var mapUrl = "http://vm-6114.idi.ntnu.no:1337/Oracle/oracle?map=";
var startWalk;
var stopWalk;
var walking;

function loadScript() {
  var gmap = document.createElement("script");
  gmap.type = "text/javascript";
  var key = "GOOGLE MAPS API KEY";
  gmap.src = "http://maps.googleapis.com/maps/api/js?key="+key+"&sensor=true&callback=initialize";
  document.body.appendChild(gmap);
  var jquery = document.createElement("script");
  jquery.type = "text/javascript";
  jquery.src = "http://code.jquery.com/jquery-1.9.1.js";
  document.body.appendChild(jquery);
}

function initialize() {
	
	getGeoLocation();
	
}

function getGeoLocation(){
	var x=document.getElementById("main");
	if (navigator.geolocation){
		navigator.geolocation.getCurrentPosition(showPosition);
	}
	else{
		x.innerHTML="Geolocation is not supported by this browser.";
	}
}
	  
function showPosition(position){
	var lat = position.coords.latitude;
	var lng = position.coords.longitude;
	
	var mapOption = {
		zoom: 13,
		center: new google.maps.LatLng(lat,lng),
		mapTypeId: google.maps.MapTypeId.ROADMAP,
	}
	
	map = new google.maps.Map(document.getElementById("map-canvas"), mapOption);
 }

 function enterSearch(e){
	 e.which = e.which || e.keyCode;
	 if(e.which == 13) {
        mapSearchAll();
    }
 }
 
 
 function findDistrict(){
 
	var index = document.getElementById('myList').selectedIndex;
	console.log("find district" +index);
	var district = "Oracle";
 
	switch(index){
	case 0:
		district = "Oracle";
	break;
	case 1:
		district = "Nordland";
	break;
	}
	
	// mapUrl = "http://vm-6114.idi.ntnu.no:1337/"+district+"/oracle?map=";
	mapUrl = "http://vm-6114.idi.ntnu.no:1337/Oracle/oracle?map=";
	console.log(mapUrl);
 }
 
 function mapSearchAll(){
	resetMap();
	var text = document.getElementById("s").value;
	if(text === "")
		document.getElementById("answer").innerHTML = "<b>Please type a question</b>";
	else
	 $.ajax({
		async: false,
		type: 'GET',
		datatype: 'json',
		 url: mapUrl+text,
		 success: function(response) {
			
			var jsonObject;
			try{
				jsonObject = $.parseJSON(response);
				var route = jsonObject.route;
				document.getElementById("answer").innerHTML = jsonObject.busstuc;
			
			}catch(err){
				document.getElementById("answer").innerHTML = response;
			}
			
			getRequest(route);
			map.setCenter(routes[0].origin);
			
			for(var x = 0; x < routes.length; x++){
			  updateDirections(routes[x],x);
			}
			
			 if(typeof startWalk != 'undefined'){
				// walkingDirection(1);
			}
			if(typeof stopWalk != 'undefined'){
				console.log("stopwalk no undefined "+stopWalk.name);
				// walkingDirection(2);
			}
			
		
		},
		 error: function(XMLHttpRequest, textStatus, errorThrown){
		 
		 }
		 });
	}
 function resetMap(){
	var mapOption = {
		zoom: 13,
		center: new google.maps.LatLng(63.430668,10.394955),
		mapTypeId: google.maps.MapTypeId.ROADMAP,
	}
	map = new google.maps.Map(document.getElementById("map-canvas"), mapOption);
 }
 
 function getRequest(route){
 
		// All request routes should be empty when this is called
 		routes = [];
		walking = [];
		// The last stop where the next request should start from
		var transit;

		// Each DirectionService request could be max 10 stops(start-stop and 8 waypoints)
		var divider = 10;
		// Divide into equal groups (Error if length is 11,21,31,41,51 etc 
		// must have both a start and a stop destination
		
		routeStops = [];
		var enters = [];		
		var exits = [];
		var transfer = false;
		var routelength = route.length;
		var pop = 0;
		
		stopWalk = [];
		startWal = [];
		
		console.log(routelength);
		for(var y = 0; y < route.length; y++){
			
			var r = route[y];
			var name = r.name;
			console.log(name);
			var type = r.type;
			console.log(type);
			var role = r.role;
			console.log(role);
			var statno = r.nr;
			var lat = r.xcoord;
			var lng = r.ycoord;
			var gps = new google.maps.LatLng(lat,lng);
			
			if(role === "start"){
				if(name !== "null"){
					console.log("start");
					startWalk = {
						name: name,
						role: role,
						type: type
					};
					routeStops.push({
						name: name,
						role: role,
						type: type
					
					});
				}
				continue;
			}else if(role === "stop"){
				if(name !== "null"){
					console.log("stop");
					stopWalk = {
						name: name,
						role: role,
						type: type
					};
					routeStops.push({
						name: name,
						role: role,
						type: type
					
					});
				}
				continue;
				
			}else if(role === "exit"){
				exits.push({
					name: name,
					type: type,
					nr: statno,
					role: role,
					gps: gps
					});
			}	
			else if(role === "enter"){
			
				enters.push({
					name: name,
					type: type,
					nr: statno,
					role: role,
					gps: gps
					});
			}	
			if(isNaN(lat) || isNaN(lng)){
				// route.pop();
				pop++;
				gps = getCoords(statno);
				if(gps == -1){
					console.log("No gps found for station: "+name);
					continue;
				}
				else
					console.log("The stop: "+name+" has no position...Getting position from multibris..."+gps+" statno:"+statno);
			}
			
			routeStops.push({
				name: name,
				type: type,
				nr: statno,
				role: role,
				gps: gps
			
			});
		
		}
		for(var p = 0; p < pop; p++){
			route.pop();
		}
		console.log("stopwalk ftw "+ stopWalk.name);
		if(exits.length > 1 || enters.length > 1)
			transfer = true;

		var loopStop = Math.ceil((routeStops.length)/divider);
		var specialCase = false;
		if(routeStops.length % divider === 1)
			specialCase = true;
		console.log("case is "+specialCase);


		for(var i = 0; i < loopStop; i++){
		// empty waypoints for each new request
			var stops = [];
			var start = null;
			var end = null;
			var addedEnter = false;
			var addedExit = false;
		// create the request for max 10 stops 
			console.log("routeStopsLength " + routeStops.length);
			for(var j = 0; j < 10 && j+i*10 < routeStops.length; j++){
				// index for getting the stops
				var index = j+i*10;
				var thisRoute = routeStops[index];
				var name = thisRoute.name;
				var type = thisRoute.type;
				var role = thisRoute.role;
				var statno = thisRoute.nr;
				var gps = thisRoute.gps;
				
				// create Bus-StopMarkers for all stops on the spesific trip
				createMarker(gps,name,statno,role);
				
				// First check if the length is 11,21,31,41 etc
				if(route.length == 3 && specialCase === true){
					console.log("breaking");
					end = gps;
					route.pop();
					makeLastRequest(index);
					break;
				}
				
				// if role is enter 
				else if((role == "enter" || j == 0 ) && start == null){
					if(j == 0 && transit != null){
						start = transit;
						if(role =="exit")
							exits.pop();
						//console.log("setting start as transit: "+transit+" nr: "+i+" item: "+j);
						}
					else if(transit != null && transfer == true){
						//console.log("Add as a waypoint: "+gps+" nr: "+i+" item: "+j);
						stops.push({
						location: gps,
						stopover: true
						});
					}else if(transit != null){
						start = transit;
						//console.log("setting start as transit: "+transit+" nr: "+i+" item: "+j);
					}
					else{
						// first loop
						console.log("adding first walk");
						walking.push(gps);
						start = gps;
						//console.log("setting start : "+gps+" nr: "+i+" item: "+j);
					}
				}	
				else if((role == "exit"|| j == 9)){
					if(j == 9){
						//console.log("Last item in part of request "+gps+" nr:"+i+" item "+j);
						end = gps;
						transit = gps;
						if(role =="exit")
							exits.pop();
						}
					else if(exits.length > 1){
						//console.log("Transfer exit station "+gps+" nr:"+i+" item "+j);
						stops.push({
							location: gps,
							stopover: true
						});
						exits.pop();
					}
					else if(exits.length == 1){
						console.log("Last stop exit loop"+gps+" nr:"+i+" item "+j);
						console.log("adding second walk "+walking.length);
						walking.push(gps);
						end = gps;
						// break;
					}
					// end = gps;
				}	
				else if((role == "pass" && (start != null  || end != null)) || (role == "enter" && start!=null)){
					//console.log("Adding waypoint "+gps);
					stops.push({
						location: gps,
						stopover: true
					});
				 }
				
				//console.log("j: "+j+" role: "+role+" name: "+name+" exitslength : "+exits.length+" end: "+end);
				route.pop();
			}
			if(stops.length != 0){
				routes.push({
					origin: start,
					destination: end,
					waypoints: stops,
					travelMode: google.maps.DirectionsTravelMode.DRIVING
				});
			}
			
			else{
				console.log("length = 0");
				routes.push({
						origin: start,
						destination: end,
						travelMode: google.maps.DirectionsTravelMode.DRIVING
					});
			}
				start = null;
				end = null;
			}
		}

		
 function makeLastRequest(index){
	console.log("index "+index);
	var start = routeStops[index-1];
	var stop = routeStops[index];
	console.log(start);
	console.log("adding second walk "+stop);
	walking.push(stop.gps);
	
	
	routes.push({
					origin: start.gps,
					destination: stop.gps,
					travelMode: google.maps.DirectionsTravelMode.DRIVING
				});
 }
 function mapSearchMarkers(){
	var text = document.getElementById("s").value;
	 $.ajax({
		async: false,
		type: 'GET',
		datatype: 'json',
		 url: 'http://192.241.103.123:8080/Oracle/oracle?map='+text,
		 success: function(response) {
			var obj = $.parseJSON(response);
			var route = obj.route;
			
			//  Create a new viewpoint bound
			var bounds = new google.maps.LatLngBounds ();
			
			for(var i = 0; i < route.length; i++){
			
				var thisRoute = route[i];
				var name = thisRoute.name;
				var type = thisRoute.type;
				var role = thisRoute.role;
				var lat = precise_round(thisRoute.xcoord,6);
				var lng = precise_round(thisRoute.ycoord,6);
				var latlng = new google.maps.LatLng(lat,lng);
				bounds.extend(latlng);
				createMarker(lat,lng,name);
			}
			map.fitBounds (bounds);
		 },
		 error: function(XMLHttpRequest, textStatus, errorThrown){
			// alert("error");
		 }
		 });

}
function createMarker(gps, name, statno,role) {
	var url;
	if(role != "start" || role != "end"){
	
	if(role == "enter"){
		url = 'pics/bus-start.png';
	}else if(role == "exit"){
		url = 'pics/bus-stop.png';
	}else if( role =="start" || role == "end"){
		url = 'pics/user_walk.png';
	}
	else{
		url = 'pics/bus3.png';
	}
	var image = {
		url: url,
	};
    var newmarker = new google.maps.Marker({
        position: gps,
        map: map,
		icon: image,
        title: name
    });
    newmarker['infowindow'] = new google.maps.InfoWindow({
			statno: statno,
			name: name,
            content: ''
         });
    google.maps.event.addListener(newmarker, 'click', function() {
		var realtime = getRealTime(this['infowindow'].statno, this['infowindow'].name);
		this['infowindow'].content = realtime;
        this['infowindow'].open(map, this);
    });
	}
}

function getRealTime(bussnr, name){
var realtime;
$.ajax({
		async: false,
		url: 'proxy.php',
		type: 'GET',
		data: {
			address: 'http://busstjener.idi.ntnu.no/MultiBRISserver/RealTime?bID='+bussnr
		},
		success: function(response) {
		
			var obj = $.parseJSON(response);
			var bussStops = obj.bussStops;
			
			var start = "Real-time information from "+name+": </br>";
			realtime = start;
			for(var i = 0; i< bussStops.length;i++){
				var line = bussStops[i].line;
				var arrivalTime = bussStops[i].arrivalTime;
				var realTime = bussStops[i].realTime;
				var dest = bussStops[i].dest;
				
				// 15/05/2013 12:51:00
				var time = (convertDateTime(arrivalTime));
				
				var bus = "Line: "+line+" to "+dest+" departs "+time+"</br>";
				realtime += bus;
				
			}
			
			
		},
		error: function(e){
		 
		}
	});
	return realtime;
}

function convertDateTime(dateTime){
    var array = dateTime.split(" ");

    var date = array[0].split("/");
    var dd = date[0];
    var mm = date[1];
    var yyyy = date[2];

    var time = array[1].split(":");
    var h = time[0];
    var m = time[1];
    var s = parseInt(time[2]); //get rid of that 00.0;
	var newdate = new Date(yyyy,mm,dd,h,m,s);
	
	var answer = h+":"+m;

    return answer;
}

function precise_round(num,decimals){
	return Math.round(num*Math.pow(10,decimals))/Math.pow(10,decimals);
}
 
function updateDirections(routes,index){
 
	var rendererOptions = {
		preserveViewport: true,         
		suppressMarkers:true,
		routeIndex:index
	};
	var directionsService = new google.maps.DirectionsService();
	var directionsDisplay = new google.maps.DirectionsRenderer(rendererOptions);
	directionsDisplay.setMap(map);

	var request = routes;
	directionsService.route(request, function(response, status) {
		if (status == google.maps.DirectionsStatus.OK) {
			directionsDisplay.setDirections(response);
		}else if(status == google.maps.DirectionsStatus.ZERO_RESULTS){
			console.log("ingen treff directonservice");
		}else if(status == google.maps.DirectionsStatus.MAX_WAYPOINTS){
			console.log("for mange via punkt");
		}else{
			console.log("Error while doing the request");
		}
  });
 }
function walkingDirection(index){
	var rendererOptions = {
		preserveViewport: true,         
		suppressMarkers:true,
		routeIndex:index
	};
	 // Start/Finish icons
	var icons = {
		  start: new google.maps.MarkerImage(
		   // URL
		   'pics/user_walk.png',
		   // (width,height)
		   new google.maps.Size( 44, 32 ),
		   // The origin point (x,y)
		   new google.maps.Point( 0, 0 ),
		   // The anchor point (x,y)
		   new google.maps.Point( 22, 32 )
		  )}; 
 
	var directionsService = new google.maps.DirectionsService();
	var directionsDisplay = new google.maps.DirectionsRenderer(rendererOptions);
	directionsDisplay.setMap(map);
	
var request 
if(index === 1){
	console.log("walking 1 "+walking[0]);
	console.log("walking 1 "+walking[1]);
	console.log("walking 2 "+walking[2]);
	request = {
				origin: startWalk.name,
				destination: walking[1],
				travelMode: google.maps.DirectionsTravelMode.WALKING,
				region: "no"
				};
	}else if( index === 2){
		console.log("second index "+stopWalk.name);
		request = {
				origin: walking[2].name,
				destination: stopWalk.name,
				travelMode: google.maps.DirectionsTravelMode.WALKING,
				region: "no"
				};
	}
	console.log("ORIGIN "+ request.origin);			
	directionsService.route(request, function(response, status) {
		if (status == google.maps.DirectionsStatus.OK) {
			directionsDisplay.setDirections(response);
			var leg = response.routes[ 0 ].legs[ 0 ];
			console.log(leg.start_location.lat);
			makeMarker(leg.start_location, leg.start_address);
		}else if(status == google.maps.DirectionsStatus.ZERO_RESULTS){
			console.log(request.origin+" "+request.destination+" "+request.waypoints.length);
			console.log("ingen treff directonservice");
		}else if(status == google.maps.DirectionsStatus.MAX_WAYPOINTS){
			console.log("for mange via punkt");
		}else{
			console.log("Error while doing the request");
		}
  });				
}


function makeMarker( position , title) {
 new google.maps.Marker({
  position: position,
  map: map,
  icon: 'pics/user_walk.png',
  title: title
 });
 }
function getCoords(bussnr){
	var gps;
	$.ajax({
		async: false,
		type: 'GET',
		datatype: 'json',
		url: 'http://busstjener.idi.ntnu.no/MultiBRISserver-test/Coords?bID='+bussnr,
		success: function(response){
			try{
				var obj = $.parseJSON(response);
				var lat = obj.lng;
				var lng = obj.lat;
				gps = new google.maps.LatLng(lat,lng);
			}catch(err){
				gps = -1;
			}
		 },
		 error: function(XMLHttpRequest, textStatus, errorThrown){
			// handle error
		 }
	});
	return gps;
}