package regtopToBusTUC.Import;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.SocketTimeoutException;
import java.net.URL;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;

import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

import regtopToBusTUC.ConvertAllRegTop;



public class Import {

	public static  void getRouteData(){
		String host = "http://labs.trafikanten.no";
		String datasets = "/archives.aspx";
		Document doc;
		try {
			doc = Jsoup.connect(host+datasets).get();
			Elements links = doc.getElementsByTag("a"); // a with href
			Elements href = links.select("a[href] ");
			Elements table = doc.select("table");
			Pattern mediaPattern = Pattern.compile(".zip");

			for (Element element : links) {
				Matcher mediaMatcher = mediaPattern.matcher( element.toString() ); 
				if(mediaMatcher.find()){
					String link = element.attr("href");
					System.out.println(host+link);
					downloadDatasets(host+link);

				}

			}
		} catch (SocketTimeoutException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}

	}
	public static void downloadDatasets(String input) throws IOException{
		String[] split = input.split("/");
		URL url = new URL(input);
		HttpURLConnection connection = (HttpURLConnection) url.openConnection();
		connection.setRequestMethod("GET");
		InputStream in = connection.getInputStream();
		Boolean created = !new File(Config.REGTOPP).exists() ? new File(Config.REGTOPP).mkdir() : true;
		String name = split[split.length-1];
		if(created){
			FileOutputStream out = new FileOutputStream(Config.REGTOPP+name);
			copy(in, out, 1024);
			out.close();
		}
		
	}

	public static void unZipDatasets(){

		
		File datasets = new File(Config.REGTOPP);
		String[] fileList = datasets.list();

		byte[] buffer = new byte[1024];

		try{

			for (int i = 0; i < fileList.length; i++) {
				String zip = Config.REGTOPP+fileList[i];
				
				String [] split = fileList[i].split("_");
				String outFolderName = split[0]+"_"+split[1];
				if(split[1].length() == 4){
					outFolderName = split[0]+"_13"+split[1]; // ad hoc - 2013
				}
				//create output directory is not exists
				File folder = new File(Config.UNZIPPED_REGTOPP);
				if(!folder.exists()){
					folder.mkdir();
				}

				//get the zip file content
				ZipInputStream zis = new ZipInputStream(new FileInputStream(zip));
				//get the zipped file list entry
				ZipEntry ze = zis.getNextEntry();

				while(ze!=null){

					String fileName = ze.getName();
					File newFile = new File(Config.UNZIPPED_REGTOPP +outFolderName+File.separator+ fileName);

					System.out.println("file unzip : "+ newFile.getAbsoluteFile());

					//create all non exists folders
					//else you will hit FileNotFoundException for compressed folder
					new File(newFile.getParent()).mkdirs();

					FileOutputStream fos = new FileOutputStream(newFile);             

					int len;
					while ((len = zis.read(buffer)) > 0) {
						fos.write(buffer, 0, len);
					}

					fos.close();   
					ze = zis.getNextEntry();
				}

				zis.closeEntry();
				zis.close();

				System.out.println("Done");
//				String[] args = {Config.UNZIPPED_REGTOPP +outFolderName, Config.PROLOGCODE, outFolderName};
//				ConvertAllRegTop.main(args);
			}
		}catch(IOException ex){
			ex.printStackTrace(); 
		}
	}


	public static void copy(InputStream input, OutputStream output, int bufferSize) throws IOException {
		byte[] buf = new byte[bufferSize];
		int n = input.read(buf);
		while (n >= 0) {
			output.write(buf, 0, n);
			n = input.read(buf);
		}
		output.flush();
	}

	public static void main(String[] args) {
		getRouteData();
		unZipDatasets();
	}

}