package regtopToBusTUC.LogReader;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

public class ReadAnswer {
	
	private static Map sortByComparator(Map unsortMap) {
		 
		List list = new LinkedList(unsortMap.entrySet());
 
		// sort list based on comparator
		Collections.sort(list, new Comparator() {
			public int compare(Object o1, Object o2) {
				return ((Comparable) ((Map.Entry) (o1)).getValue())
                                       .compareTo(((Map.Entry) (o2)).getValue());
			}
		});
 
		// put sorted list into map again
                //LinkedHashMap make sure order in which keys were inserted
		Map sortedMap = new LinkedHashMap();
		for (Iterator it = list.iterator(); it.hasNext();) {
			Map.Entry entry = (Map.Entry) it.next();
			sortedMap.put(entry.getKey(), entry.getValue());
		}
		return sortedMap;
	}
 
	public static void printMap(Map<String, String> map){
		for (Map.Entry entry : map.entrySet()) {
			System.out.println("Key : " + entry.getKey() 
                                   + " Value : " + entry.getValue());
		}
	}


	public static void main(String[] args) throws IOException {

		String thisLine;
		HashMap<String, Integer> map = new HashMap<>();

		//Open the file for reading
		try {
			BufferedReader br = new BufferedReader(new FileReader(new File("logs/from_to.csv")));
			while ((thisLine = br.readLine()) != null) { // while loop begins here
				String[] line = thisLine.split("\t");
				String word = line[0];
				int count = Integer.parseInt(line[1]);
				map.put(word, count);
			} // end while 
		} // end try
		
		catch (IOException e) {
			System.err.println("Error: " + e);
		}
		Map<String, String> sortedMap = sortByComparator(map);
		printMap(sortedMap);
		BufferedWriter outFile = new BufferedWriter( new FileWriter("logs/fromandto.txt") );
		for (Map.Entry entry : sortedMap.entrySet()) {
			outFile.write(entry.getKey()+"\t"+entry.getValue()+System.lineSeparator());
		}
		outFile.close();
		
	} // end for



}
